<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml">
    <!-- param name: managedBean (should extend AbstractResultSender) -->
    <!-- BATTERY CENTRIC -->
    <s:div rendered="#{managedBean.selectedOrder != null and managedBean.messageStructure.equals(managedBean.batteryCentric)}"
           id="batteryCentricDiv">
        <s:div rendered="#{managedBean.editOrder}" id="editOrderDiv">
            <gri:panel>
                <f:facet name="header">
                    <h:outputText value="#{messages['gazelle.ordermanager.CreateOrderbattery']}"/>
                    <a4j:commandLink value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                     actionListener="#{managedBean.fillOrderRandomly()}" immediate="true"
                                     render="batteryCentricDiv">
                        <span class="gzl-icon-random"/>
                    </a4j:commandLink>
                </f:facet>
                <!-- this page displays all the attributes to be filled by the user -->
                <f:subview id="subview_1">
                    <ui:include src="/lab/fillingLabOrder.xhtml">
                        <ui:param name="order" value="#{managedBean.selectedOrder}"/>
                        <ui:param name="displayExtraParamForOF" value="true"/>
                        <ui:param name="isWorkOrder" value="#{managedBean.workOrder}"/>
                        <ui:param name="valueResultStatus" value="true"/>
                    </ui:include>
                </f:subview>
                <f:facet name="footer">
                    <!-- command button -->
                    <a4j:commandButton value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                       actionListener="#{managedBean.fillOrderRandomly()}" immediate="true"
                                       render="editOrderDiv" styleClass="gzl-btn-blue"/>
                    <a4j:commandButton value="#{messages['gazelle.ordermanager.CreateASpecimenForOrder']}"
                                       actionListener="#{managedBean.createSpecimenForOrder()}"
                                       render="batteryCentricDiv" styleClass="gzl-btn-green"/>
                </f:facet>
            </gri:panel>
        </s:div>
        <s:div rendered="#{not managedBean.editOrder}" id="orderDetails">
            <!-- order details -->
            <gri:panel>
                <f:facet name="header">#{messages['gazelle.ordermanager.OrderDetails']}</f:facet>
                <f:subview id="subview_2">
                    <ui:include src="/lab/labOrderDetails.xhtml">
                        <ui:param name="selectedOrder" value="#{managedBean.selectedOrder}"/>
                        <ui:param name="enableStatusEdit" value="true"/>
                        <ui:param name="managedBean" value="#{managedBean}"/>
                    </ui:include>
                </f:subview>
                <!-- defined specimens for the current order -->
                <h2>#{messages['gazelle.ordermanager.RelatedSpecimens']}</h2>
                <h:outputText value="#{messages['gazelle.ordermanager.BelowIsTheListOfSpecimensForTheCurrentOrder']}"
                              rendered="#{not empty managedBean.selectedOrder.specimens}"
                              styleClass="help-block"/>
                <h:outputText value="#{messages['gazelle.ordermanager.NoSpecimenSpecifiedForTheCurrentOrderYet']}"
                              rendered="#{empty managedBean.selectedOrder.specimens}"
                              styleClass="help-block"/>
                <rich:dataTable value="#{managedBean.selectedOrder.specimens}" var="currentSpecimen"
                                rendered="#{not empty managedBean.selectedOrder.specimens}" id="spmlist">
                    <ui:include src="/lab/specimenColumns.xhtml">
                        <ui:param name="specimen" value="#{currentSpecimen}"/>
                    </ui:include>
                    <g:column>
                        <ui:define name="header">#{messages['users.Action']}</ui:define>
                        <a4j:commandLink actionListener="#{managedBean.removeSpecimenFromOrder(currentSpecimen)}"
                                         render="orderDetails"
                                         title="#{messages['gazelle.ordermanager.RemoveThisSpecimenFromTheOrder']}">
                            <s:span styleClass="gzl-icon-trash-o"/>
                        </a4j:commandLink>
                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="ds"/>
                            <ui:param name="dataTableId" value="spmlist"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
                <f:facet name="footer">
                    <a4j:commandButton value="#{messages['gazelle.ordermanager.AddASpecimenToThisOrder']}"
                                       actionListener="#{managedBean.createSpecimenForOrder()}"
                                       rendered="#{not empty managedBean.selectedOrder.specimens}"
                                       styleClass="gzl-btn-green"
                                       immediate="true"
                                       render="orderDetails"/>
                </f:facet>
            </gri:panel>
            <br/>
            <!-- specimen creation -->
            <s:div rendered="#{managedBean.editSpecimen}">
                <gri:panel pid="specimenCreation">
                    <f:facet name="header">
                        <h:outputText value="#{messages['gazelle.ordermanager.CreateSpecimenForCurrentOrder']}"/>
                        <!-- button to fill randomly the specimen -->
                        <a4j:commandLink value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                         actionListener="#{managedBean.fillSpecimenRandomly()}" immediate="true"
                                         render="specimenCreation">
                            <span class="gzl-icon-random"/>
                        </a4j:commandLink>
                    </f:facet>
                    <f:subview id="subview_3">
                        <ui:include src="/lab/fillingSpecimen.xhtml">
                            <ui:param name="specimen" value="#{managedBean.selectedSpecimen}"/>
                            <ui:param name="managedBean" value="#{managedBean}"/>
                            <ui:param name="askForNumberOfContainers" value="true"/>
                        </ui:include>
                    </f:subview>
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                           actionListener="#{managedBean.fillSpecimenRandomly()}" immediate="true"
                                           render="specimenCreation" styleClass="gzl-btn-blue"/>
                        <a4j:commandButton value="#{messages['gazelle.ordermanager.AddToCurrentOrder']}"
                                           actionListener="#{managedBean.addSpecimenToOrder()}"
                                           render="orderDetails" styleClass="gzl-btn-blue"/>
                    </f:facet>
                </gri:panel>
            </s:div>
        </s:div>
    </s:div>
    <!-- SPECIMEN CENTRIC -->
    <s:div rendered="#{managedBean.selectedSpecimen != null and managedBean.messageStructure.equals(managedBean.specimenCentric)}"
           id="specimenCentricDiv">
        <s:div id="editSpecimenDiv" rendered="#{managedBean.editSpecimen}">
            <gri:panel pid="editSpecimenPanel">
                <f:facet name="header">
                    <h:outputText value="#{messages['gazelle.ordermanager.CreateSpecimen']}"/>
                    <span style="width:5px;"/>
                    <a4j:commandLink title="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                     actionListener="#{managedBean.fillSpecimenRandomly()}" immediate="true"
                                     render="editSpecimenDiv">
                        <span class="gzl-icon-random"/>
                    </a4j:commandLink>
                </f:facet>
                <f:subview id="fill_spm"
                           rendered="#{not managedBean.selectedSpecimen.simulatedActor.keyword.equals('ANALYZER')}">
                    <ui:include src="/lab/fillingSpecimen.xhtml">
                        <ui:param name="specimen" value="#{managedBean.selectedSpecimen}"/>
                        <ui:param name="managedBean" value="#{managedBean}"/>
                        <ui:param name="askForNumberOfContainers" value="true"/>
                    </ui:include>
                </f:subview>
                <s:div rendered="#{managedBean.selectedSpecimen.simulatedActor.keyword.equals('ANALYZER')}">
                    <f:subview id="fill_spm_4_law">
                        <ui:include src="/lab/fillingSpecimen4LAW.xhtml">
                            <ui:param name="specimen" value="#{managedBean.selectedSpecimen}"/>
                            <ui:param name="managedBean" value="#{managedBean}"/>
                            <ui:param name="askForNumberOfContainers" value="false"/>
                        </ui:include>
                    </f:subview>
                    <h2>#{messages['gazelle.ordermanager.RelatedContainer']}</h2>
                    <f:subview id="fill_sac_4_law">
                        <ui:include src="/lab/fillingContainer4LAW.xhtml">
                            <ui:param name="currentContainer" value="#{managedBean.selectedContainer}"/>
                        </ui:include>
                    </f:subview>
                </s:div>
                <f:facet name="footer">
                    <a4j:commandButton value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                       actionListener="#{managedBean.fillSpecimenRandomly()}" immediate="true"
                                       render="editSpecimenDiv" styleClass="gzl-btn-blue"/>
                    <a4j:commandButton value="#{messages['gazelle.ordermanager.CreateAnOrderForSpecimen']}"
                                       actionListener="#{managedBean.createOrderForSpecimen()}"
                                       render="specimenCentricDiv" styleClass="gzl-btn-green"/>
                </f:facet>
            </gri:panel>
        </s:div>
        <s:div id="specimenDetails" rendered="#{not managedBean.editSpecimen}">
            <gri:panel>
                <f:facet name="header">#{messages['gazelle.ordermanager.SpecimenDetails']}</f:facet>
                <f:subview id="spm_details_2">
                    <ui:include src="/lab/specimenDetails.xhtml">
                        <ui:param name="specimen" value="#{managedBean.selectedSpecimen}"/>
                    </ui:include>
                </f:subview>
                <!-- defined orders for the current specimen -->
                <h2>#{messages['gazelle.ordermanager.RelatedOrders']}</h2>
                <h:outputText value="#{messages['gazelle.ordermanager.BelowIsTheListOfOrdersForTheCurrentSpecimen']}"
                              rendered="#{not empty managedBean.selectedSpecimen.orders}"
                              styleClass="help-block"/>
                <h:outputText value="#{messages['gazelle.ordermanager.NoOrderSpecifiedForTheCurrentSpecimenYet']}"
                              rendered="#{empty managedBean.selectedSpecimen.orders}"
                              styleClass="help-block"/>
                <rich:dataTable value="#{managedBean.selectedSpecimen.orders}" var="currentOrder"
                                rendered="#{not empty managedBean.selectedSpecimen.orders}"
                                rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                id="orclist">
                    <ui:include src="/common/orderColumns.xhtml">
                        <ui:param name="currentOrder" value="#{currentOrder}"/>
                        <ui:param name="displayEncounterInfo" value="false"/>
                        <ui:param name="enableStatusEdit" value="false"/>
                    </ui:include>
                    <g:column>
                        <ui:define name="header">#{messages['users.Action']}</ui:define>
                        <a4j:commandLink actionListener="#{managedBean.removeOrderFromSpecimen(currentOrder)}"
                                         title="#{messages['gazelle.ordermanager.RemoveThisOrderFromTheSpecimen']}"
                                         render="specimenDetails">
                            <s:span styleClass="gzl-icon-trash-o"/>
                        </a4j:commandLink>
                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="ds"/>
                            <ui:param name="dataTableId" value="orclist"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
                <f:facet name="footer">
                    <a4j:commandButton value="#{messages['gazelle.ordermanager.AddAnOrderForThisSpecimen']}"
                                       actionListener="#{managedBean.createOrderForSpecimen()}"
                                       styleClass="gzl-btn-blue"
                                       render="specimenDetails"/>
                </f:facet>
            </gri:panel>
            <!-- order creation -->
            <br/>
            <s:div rendered="#{managedBean.editOrder}">
                <gri:panel pid="orderCreation">
                    <f:facet name="header">
                        <h:outputText value="#{messages['gazelle.ordermanager.CreateOrderForCurrentSpecimen']}"/>
                        <a4j:commandLink title="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                         actionListener="#{managedBean.fillOrderRandomly()}" immediate="true"
                                         render="orderCreation">
                            <span class="gzl-icon-random"/>
                        </a4j:commandLink>
                    </f:facet>
                    <!-- fill randomly button -->
                    <f:subview id="fill_orc_scratch">
                        <ui:include src="/lab/fillingLabOrder.xhtml">
                            <ui:param name="order" value="#{managedBean.selectedOrder}"/>
                            <ui:param name="displayExtraParamForOF" value="true"/>
                            <ui:param name="isWorkOrder" value="#{managedBean.workOrder}"/>
                            <ui:param name="valueResultStatus" value="true"/>
                        </ui:include>
                    </f:subview>
                    <!-- command button -->
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                           actionListener="#{managedBean.fillOrderRandomly()}" immediate="true"
                                           styleClass="gzl-btn-blue"
                                           render="orderCreation"/>
                        <a4j:commandButton value="#{messages['gazelle.ordermanager.AddToCurrentSpecimen']}"
                                           actionListener="#{managedBean.addOrderToSpecimen()}"
                                           styleClass="gzl-btn-blue"
                                           render="specimenDetails"/>
                    </f:facet>
                </gri:panel>
            </s:div>
        </s:div>
    </s:div>
    <!-- CONTAINER CENTRIC -->
    <s:div rendered="#{managedBean.selectedSpecimen != null and managedBean.messageStructure.equals(managedBean.containerCentric)}"
           id="containerCentricDiv">
        <s:div id="editSpecimenContainerDiv" rendered="#{managedBean.editSpecimen}">
            <gri:panel>
                <f:facet name="header">
                    <h:outputText value="#{messages['gazelle.ordermanager.CreateSpecimen']}"/>
                    <!-- button to fill randomly the specimen -->
                    <a4j:commandLink title="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                     actionListener="#{managedBean.fillSpecimenRandomly()}" immediate="true"
                                     render="editSpecimenContainerDiv">
                        <span class="gzl-icon-random"/>
                    </a4j:commandLink>
                </f:facet>
                <f:subview id="fill_spm_3">
                    <ui:include src="/lab/fillingSpecimen.xhtml">
                        <ui:param name="specimen" value="#{managedBean.selectedSpecimen}"/>
                        <ui:param name="managedBean" value="#{managedBean}"/>
                        <ui:param name="askForNumberOfContainers" value="false"/>
                    </ui:include>
                </f:subview>
                <f:facet name="footer">
                    <a4j:commandButton value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                       actionListener="#{managedBean.fillSpecimenRandomly()}" immediate="true"
                                       styleClass="gzl-btn-blue"
                                       render="editSpecimenContainerDiv"/>
                    <a4j:commandButton value="#{messages['gazelle.ordermanager.CreateAContainerForSpecimen']}"
                                       actionListener="#{managedBean.createContainerForSpecimen()}"
                                       styleClass="gzl-btn-green"
                                       render="containerCentricDiv"/>
                </f:facet>
            </gri:panel>
        </s:div>
        <s:div id="specimenContainerDetails" rendered="#{not managedBean.editSpecimen}">
            <gri:panel>
                <f:facet name="header">#{messages['gazelle.ordermanager.SpecimenDetails']}</f:facet>
                <f:subview id="subview_spm_det">
                    <ui:include src="/lab/specimenDetails.xhtml">
                        <ui:param name="specimen" value="#{managedBean.selectedSpecimen}"/>
                    </ui:include>
                </f:subview>
                <!-- defined orders for the current specimen -->
                <h2>#{messages['gazelle.ordermanager.RelatedContainers']}</h2>
                <h:outputText
                        value="#{messages['gazelle.ordermanager.BelowIsTheListOfContainersForTheCurrentSpecimen']}"
                        styleClass="help-block"
                        rendered="#{not empty managedBean.selectedSpecimen.containers}"/>
                <h:outputText value="#{messages['gazelle.ordermanager.NoOrderSpecifiedForTheCurrentSpecimenYet']}"
                              styleClass="help-block"
                              rendered="#{empty managedBean.selectedSpecimen.containers}"/>
                <a4j:repeat id="containersList" value="#{managedBean.selectedSpecimen.containers}"
                            var="currentContainer" rendered="#{not empty managedBean.selectedSpecimen.containers}">
                    <s:div id="currentContainerDiv">
                        <dl class="dl-horizontal">
                            <s:decorate template="/layout/display/_data_list_item.xhtml">
                                <ui:define name="label">#{messages['gazelle.ordermanager.ContainerIdentifier']}
                                </ui:define>
                                <h:panelGrid columns="5">
                                    <h:outputText value="#{currentContainer.containerIdentifier}"/>
                                    <gdk:spacer width="5px"/>
                                    <a4j:commandLink
                                            actionListener="#{managedBean.removeContainerFromSpecimen(currentContainer)}"
                                            title="#{messages['gazelle.ordermanager.RemoveThisContainerFromTheSpecimen']}"
                                            render="containersList">
                                        <s:span styleClass="gzl-icon-trash-o"/>
                                    </a4j:commandLink>
                                    <gdk:spacer width="5px"/>
                                    <a4j:commandLink
                                            actionListener="#{managedBean.createOrderForContainer(currentContainer)}"
                                            render="containerCentricDiv">
                                        <h:panelGroup>
                                            <s:span styleClass="gzl-icon-plus"/>
                                            <h:outputText
                                                    value="#{messages['gazelle.ordermanager.AddAnOrderForThisContainer']}"/>
                                        </h:panelGroup>
                                    </a4j:commandLink>
                                </h:panelGrid>
                            </s:decorate>
                        </dl>
                        <rich:dataTable value="#{currentContainer.orders}" var="currentOrder"
                                        rendered="#{not empty currentContainer.orders}" render="ds"
                                        rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                        id="orclist2">
                            <ui:include src="/common/orderColumns.xhtml">
                                <ui:param name="currentOrder" value="#{currentOrder}"/>
                                <ui:param name="displayEncounterInfo" value="false"/>
                            </ui:include>
                            <g:column>
                                <ui:define name="header">#{messages['users.Action']}</ui:define>
                                <a4j:commandLink
                                        actionListener="#{managedBean.removeOrderFromContainer(currentContainer, currentOrder)}"
                                        render="currentContainerDiv"
                                        title="#{messages['gazelle.ordermanager.RemoveThisOrderFromTheContainer']}">
                                    <s:span styleClass="gzl-icon-trash-o"/>
                                </a4j:commandLink>
                            </g:column>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds"/>
                                    <ui:param name="dataTableId" value="oclist2"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                    </s:div>
                </a4j:repeat>
                <a4j:commandButton value="#{messages['gazelle.ordermanager.AddAContainerForSpecimen']}"
                                   actionListener="#{managedBean.createContainerForSpecimen()}"
                                   styleClass="gzl-btn-green"
                                   render="specimenContainerDetails"/>
            </gri:panel>
            <!-- order creation -->
            <br/>
            <gri:panel pid="order2Creation" rendered="#{managedBean.selectedOrder != null}">
                <f:facet name="header">#{messages['gazelle.ordermanager.CreateOrderForCurrentContainer']}</f:facet>
                <dl class="dl-horizontal">
                    <s:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['gazelle.ordermanager.ContainerIdentifier']}</ui:define>
                        <h:outputText value="#{managedBean.selectedContainer.containerIdentifier}"/>
                    </s:decorate>
                </dl>
                <f:subview id="subview_11">
                    <ui:include src="/lab/fillingLabOrder.xhtml">
                        <ui:param name="order" value="#{managedBean.selectedOrder}"/>
                        <ui:param name="displayExtraParamForOF" value="true"/>
                        <ui:param name="isWorkOrder" value="#{managedBean.workOrder}"/>
                        <ui:param name="valueResultStatus" value="true"/>
                    </ui:include>
                </f:subview>
                <!-- command button -->
                <f:facet name="footer">
                    <a4j:commandButton value="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                       actionListener="#{managedBean.fillOrderRandomly()}" immediate="true"
                                       styleClass="gzl-btn-blue"
                                       render="order2Creation"/>
                    <a4j:commandButton value="#{messages['gazelle.ordermanager.AddToCurrentContainer']}"
                                       actionListener="#{managedBean.addOrderToContainer()}"
                                       styleClass="gzl-btn-blue"
                                       render="specimenContainerDetails"/>
                </f:facet>
            </gri:panel>
        </s:div>
    </s:div>
</ui:composition>
